'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _getGithubAuthorizeUrl = require('../modules/getGithubAuthorizeUrl');

var _getGithubAuthorizeUrl2 = _interopRequireDefault(_getGithubAuthorizeUrl);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var handleClick = function handleClick(githubClientId, href) {
  return function (event) {
    event.preventDefault();
    window.location = (0, _getGithubAuthorizeUrl2.default)(githubClientId, href);
  };
};

var PrivateLink = function PrivateLink(Link) {
  var GithubPrivateLink = function GithubPrivateLink(props, context) {
    var href = props.href,
        children = props.children,
        additionalProps = (0, _objectWithoutProperties3.default)(props, ['href', 'children']);
    var githubClientId = context.githubClientId,
        githubUser = context.githubUser;


    if (githubUser) {
      return _react2.default.createElement(
        Link,
        (0, _extends3.default)({ href: href }, additionalProps),
        children
      );
    }

    // We're making the assumption (unwisely?) that the child is an `<a>`
    // without an href
    var linkProps = (0, _extends3.default)({}, additionalProps, {
      onClick: handleClick(githubClientId, href)
    });

    var child = _react.Children.only(children);

    if (child.type === 'a' && !('href' in child.props)) {
      linkProps = (0, _extends3.default)({}, linkProps, { href: '#' });
    }

    return (0, _react.cloneElement)(child, linkProps);
  };

  GithubPrivateLink.propTypes = {
    href: _react.PropTypes.string.isRequired,
    children: _react.PropTypes.object.isRequired
  };

  GithubPrivateLink.contextTypes = {
    githubClientId: _react.PropTypes.string,
    githubUser: _react.PropTypes.shape({
      login: _react.PropTypes.string
    })
  };

  return GithubPrivateLink;
};

exports.default = PrivateLink;